//
// Created by jovian on 18/07/17.
//

#ifndef TINYSHOOTER_GAMECORE_H
#define TINYSHOOTER_GAMECORE_H

// Read hardware commands
#include "Control/Input.h"
#include "Control/Camera.h"

// For game display
#include "Graphics/Renderer.h"

// Host stars and planets
#include "Contents/Universe.h"

class GameCore {
public :
    GameCore();
    virtual ~GameCore();

    bool initialize(); // Create attributes, return false if failure occurred
    void startQuickGame(); // Start a default game

protected:
    Input *m_input;
    Renderer *m_rend;
    Universe *m_universe;
    Camera *m_camera;
};


#endif //TINYSHOOTER_GAMECORE_H
